package com.poc.web.mapper;

import java.util.Optional;

import org.springframework.stereotype.Component;

import com.poc.web.entity.Employee;
import com.poc.web.model.Emp;

import reactor.core.publisher.Mono;
@Component
public class EmployeeMapper implements EntityMapper {

	@Override
	public Object mapPojoToEntity(Object pojo) {
		Optional<Object> obj=Optional.ofNullable(pojo);
		if(obj.isPresent()) {
			Emp emp=(Emp)pojo;
			Employee employee=new Employee();
			employee.setDeptId(emp.getDeptId());
			employee.setDeptName(emp.getDeptName());
			employee.setEmpId(emp.getEmpId());
			employee.setEmpName(emp.getEmpName());
			employee.setEmpSal(emp.getEmpSal());
			return employee;
		}
		return null;
	}

	@Override
	public Object mapEntityToPojo(Object entity) {
		if(entity instanceof Mono) {
			System.out.println("Mono");
		}else if(entity instanceof Employee) {
			System.out.println("Employee");
		}
		Optional<Object> obj=Optional.ofNullable(entity);
		if(obj.isPresent()) {
			
			Employee employee=(Employee)entity;
			Emp emp=new Emp();
			emp.setDeptId(employee.getDeptId());
			emp.setDeptName(employee.getDeptName());
			emp.setEmpId(employee.getEmpId());
			emp.setEmpName(employee.getEmpName());
			emp.setEmpSal(employee.getEmpSal());
			
			return emp;
		}
		return null;
	}

}
